package com.fp.persistence.pgeneral.gene;

import javax.persistence.Column;
import java.io.Serializable;
import com.fp.dto.hb.HibernateId;
import java.lang.reflect.Field;
import javax.persistence.Embeddable;
import javax.persistence.Transient;

/**Clase que hace referencia a la Clave Primaria de TGENEAREA*/
@Embeddable
public class TgeneAreaKey  extends com.fp.dto.AbstractDataTransport  implements Serializable,Cloneable,HibernateId{
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
@Column(name="COMPANYCODE", nullable=false,updatable=false)

/**
* Codigo de compania a la que pertenece el departamento
*/
private Integer companycode;

@Column(name="AREACODE", nullable=false,updatable=false)

/**
* Codigo de area
*/
private Integer areacode;

/**Contructor por defecto*/
public TgeneAreaKey(){}
/**Contructor de TgeneAreaKey
@param pCompanycode Codigo de compania a la que pertenece el departamento
@param pAreacode Codigo de area
*/
public TgeneAreaKey(Integer pCompanycode,Integer pAreacode){
 companycode=pCompanycode;
 areacode=pAreacode;
}
/**Obtiene el valor de companycode
@return valor de companycode*/
public Integer getCompanycode(){
  return companycode;
}
/**Fija el valor de companycode
@param pCompanycode nuevo Valor de companycode*/
public void setCompanycode(Integer pCompanycode){
  companycode=pCompanycode;
}

/**Obtiene el valor de areacode
@return valor de areacode*/
public Integer getAreacode(){
  return areacode;
}
/**Fija el valor de areacode
@param pAreacode nuevo Valor de areacode*/
public void setAreacode(Integer pAreacode){
  areacode=pAreacode;
}

/**Implementación de la comparación de TgeneAreaKey
@param o Objeto de comparación
*/
public boolean equals(Object o){
  if (o == null)return false;
  if (! (o instanceof TgeneAreaKey))return false;
  TgeneAreaKey that = (TgeneAreaKey) o;
  if (this.getCompanycode() == null || that.getCompanycode() == null){
      return false;
  }
  if (! this.getCompanycode().equals(that.getCompanycode())){
    return false;
  }
  if (this.getAreacode() == null || that.getAreacode() == null){
      return false;
  }
  if (! this.getAreacode().equals(that.getAreacode())){
    return false;
  }
  return true;
}
/**Implementación del método hashCode bajo el patrón de Bloch
@return hashCode de la instancia TgeneAreaKey
*/
public int hashCode(){
  if (this.hashValue == 0){
    int result = 17;
    result = result * 37 + (this.getCompanycode() == null ? 0 : this.getCompanycode().hashCode());
    result = result * 37 + (this.getAreacode() == null ? 0 : this.getAreacode().hashCode());
    this.hashValue = result;
  }
  return this.hashValue;
}
public Object cloneMe() throws CloneNotSupportedException {
  return this.clone();
}
/**Implementación toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+="pk."+name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
}
